## petsc 3.19.6+dfsg1

=== share/petsc/CMakeLists.txt ===
#
#  This is a sample CMakeLists.txt suitable for direct use with a new PETSc application or
#  you can add fragments of material below to an existing applications CMakeLists.txt
#
#  Usage:  To build ex1 from ex1.c
#    rm -fr build
#    mkdir build
#    cd build
#    cmake ..
#    make
#    ./ex1
#
#  By default it gets both the compiler information and the library information from PETSc
#
cmake_minimum_required(VERSION 3.1.0)

set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)

# set root of location to find PETSc's pkg-config
set(PETSC $ENV{PETSC_DIR}/$ENV{PETSC_ARCH})
set(ENV{PKG_CONFIG_PATH} ${PETSC}/lib/pkgconfig)

# Remove the lines below if you do not wish to have PETSc determine the compilers
execute_process ( COMMAND pkg-config PETSc --variable=ccompiler COMMAND tr -d '\n' OUTPUT_VARIABLE C_COMPILER)
SET(CMAKE_C_COMPILER ${C_COMPILER})
execute_process ( COMMAND pkg-config PETSc --variable=cxxcompiler COMMAND tr -d '\n' OUTPUT_VARIABLE CXX_COMPILER)
if (CXX_COMPILER)
  SET(CMAKE_CXX_COMPILER ${CXX_COMPILER})
endif (CXX_COMPILER)
execute_process ( COMMAND pkg-config PETSc --variable=fcompiler COMMAND tr -d '\n' OUTPUT_VARIABLE FORTRAN_COMPILER)
if (FORTRAN_COMPILER)
  SET(CMAKE_Fortran_COMPILER ${FORTRAN_COMPILER})
  enable_language(Fortran)
endif (FORTRAN_COMPILER)

#  tells CMake to build the application ex1 from the source file ex1.c
#  this must appear AFTER the compilers are set
project(ex1)
add_executable(ex1 ex1.c)

find_package(PkgConfig REQUIRED)
pkg_search_module(PETSC REQUIRED IMPORTED_TARGET PETSc)
target_link_libraries(ex1 PkgConfig::PETSC)

=== debian/changelog ===
petsc (3.19.6+dfsg1-2.2ubuntu2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 06:45:22 +0000

petsc (3.19.6+dfsg1-2.2ubuntu1) noble; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - debian/patches/gcc-13.patch: fix misdetection of required C++
      library with gcc-13.
    - debian/rules: pass -Wl,-z,defs to the linker to guard against future
      misbuilds.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 04 Mar 2024 09:20:10 +0100

petsc (3.19.6+dfsg1-2.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix extraneous X-Time64-Compat declarations.
  * Fix substitution of soname in maintainer scripts.  Closes: #1065217.

 -- Steve Langasek <vorlon@debian.org>  Sun, 03 Mar 2024 21:40:10 +0000

petsc (3.19.6+dfsg1-2.1ubuntu1) noble; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - debian/patches/gcc-13.patch: fix misdetection of required C++
      library with gcc-13.
    - debian/rules: pass -Wl,-z,defs to the linker to guard against future
      misbuilds.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 01 Mar 2024 12:16:48 +0100

petsc (3.19.6+dfsg1-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1064332

 -- Benjamin Drung <bdrung@debian.org>  Thu, 29 Feb 2024 20:22:10 +0000

petsc (3.19.6+dfsg1-2ubuntu1) noble; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - debian/patches/gcc-13.patch: fix misdetection of required C++
      library with gcc-13.
    - debian/rules: pass -Wl,-z,defs to the linker to guard against future
      misbuilds.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 22 Jan 2024 08:53:48 +0100

petsc (3.19.6+dfsg1-2) unstable; urgency=medium

  * Update debian/patches/soname_extension to also add a define PETSC_LIB_EXT,
    and use it when determining the name of the dynamic library to be loaded
    with -library_preload.

 -- Francesco Ballarin <francesco.ballarin@unicatt.it>  Sun, 21 Jan 2024 06:41:21 +0000

petsc (3.19.6+dfsg1-1ubuntu1) noble; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - debian/patches/gcc-13.patch: fix misdetection of required C++
      library with gcc-13.
    - debian/rules: pass -Wl,-z,defs to the linker to guard against future
      misbuilds.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 24 Dec 2023 09:35:58 +0100

petsc (3.19.6+dfsg1-1) unstable; urgency=medium

  * New upstream release.
    - applies debian patches fix_check_error_MR6616.diff and
      pkgdir_not_petscdir_PR6434.diff
  * dh_clean: remove pycache generated in lib/petsc/bin.
    Closes: #1045544.

 -- Drew Parsons <dparsons@debian.org>  Thu, 21 Dec 2023 10:05:19 +0100

petsc (3.19.2+dfsg1-1exp2) experimental; urgency=medium

  * debian patch pkgdir_not_petscdir_PR6434.diff applies upstream
    PR6434 to fix SLEPc build.

 -- Drew Parsons <dparsons@debian.org>  Tue, 04 Jul 2023 12:57:51 +0200

petsc (3.19.2+dfsg1-1exp1) experimental; urgency=medium

  * New upstream release.
    - new ABI 3.19
  * debian patch fix_check_error_MR6616.diff applies upstream MR6616
    to fix problems with new handling of errors when running tests
  * Use language_data.js from libjs-sphinxdoc with docs

 -- Drew Parsons <dparsons@debian.org>  Tue, 20 Jun 2023 16:17:08 +0200

petsc (3.18.6+dfsg1-1ubuntu3) noble; urgency=medium

  * Rebuild against new libcholmod5.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 23 Nov 2023 17:47:49 +0100

petsc (3.18.6+dfsg1-1ubuntu2) noble; urgency=medium

  * Rebuild against new libspqr4.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 27 Oct 2023 10:49:22 +0200

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

DEB_SOURCE_PACKAGE := $(strip $(shell egrep '^Source: ' debian/control | cut -f 2 -d ':'))
DEB_VERSION := $(shell dpkg-parsechangelog -S Version)
DEB_NOEPOCH_VERSION := $(shell echo $(DEB_VERSION) | cut -d: -f2-)
DEB_UPSTREAM_VERSION := $(shell echo $(DEB_NOEPOCH_VERSION) | sed 's/-[^-]*$$//')
DEB_STRIPPED_UPSTREAM_VERSION = $(shell echo $(DEB_UPSTREAM_VERSION) | sed -e 's/[\.\+]dfsg.*$$//' )

# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append FLAGS
export DEB_CFLAGS_MAINT_APPEND  = -fPIC
export DEB_CXXFLAGS_MAINT_APPEND  = -fPIC
export DEB_FFLAGS_MAINT_APPEND  = -fPIC -ffree-line-length-0
export DEB_FCFLAGS_MAINT_APPEND  = $(DEB_FFLAGS_MAINT_APPEND)
export DEB_LDFLAGS_MAINT_APPEND = -fPIC

# keep the build dir (in the -fdebug-prefix-map flag) out of the installed config files,
# by applying the flag only at build time not configure time
export CFLAGS_NO_DEBUG_PREFIX_MAP := $(shell echo $(CFLAGS) | sed "s/ -fdebug-prefix-map=[^ ]* / /" )
export CFLAGS_DEBUG_PREFIX_MAP := $(shell echo $(CFLAGS) | sed -n "s/^.*\(-fdebug-prefix-map=[^ ]*\) .*$$/\1/p" )
export CXXFLAGS_NO_DEBUG_PREFIX_MAP := $(shell echo $(CXXFLAGS) | sed "s/ -fdebug-prefix-map=[^ ]* / /" )
export CXXFLAGS_DEBUG_PREFIX_MAP := $(shell echo $(CXXFLAGS) | sed -n "s/^.*\(-fdebug-prefix-map=[^ ]*\) .*$$/\1/p" )
export FCFLAGS_NO_DEBUG_PREFIX_MAP := $(shell echo $(FCFLAGS) | sed "s/ -fdebug-prefix-map=[^ ]* / /" )
export FCFLAGS_DEBUG_PREFIX_MAP := $(shell echo $(FCFLAGS) | sed -n "s/^.*\(-fdebug-prefix-map=[^ ]*\) .*$$/\1/p" )
export FFLAGS_NO_DEBUG_PREFIX_MAP := $(shell echo $(FFLAGS) | sed "s/ -fdebug-prefix-map=[^ ]* / /" )
export FFLAGS_DEBUG_PREFIX_MAP := $(shell echo $(FFLAGS) | sed -n "s/^.*\(-fdebug-prefix-map=[^ ]*\) .*$$/\1/p" )

# Overriding this with "contrib" attempts to link with parmetis (unimplemented).
DEBIAN_DIST=main

export DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# On Alpha, override this with debian/rules PETSC_ARCH=linux_alpha_dec binary
# to build PETSc libs with the Compaq compilers, though that requires at least:
# libots, cpml-ev(5|6), cxml-ev(5|6), cfal and ccc.
# Note that only arch-dependent .debs are generated when you do this.
PETSC_ARCH=$(DEB_HOST_MULTIARCH)

CPU_COUNT := $(shell /usr/bin/nproc )
export DEB_BUILD_OPTIONS ?= parallel=$(CPU_COUNT)

# This defines the MPI implementation to use.  The easiest way to override this
# default is to specify while building, e.g. debian/rules PETSC_MPI=lam binary.
# Again, only arch-dependent .debs are generated when you do this.
# Note that as of PETSc 2.3.0 this only specifies the name of the PETSc
# packages, the implementation is chosen by BuildSystem according to what's
# available at build time.
include /usr/share/mpi-default-dev/debian_defaults
PETSC_MPI=$(ARCH_DEFAULT_MPI_IMPL)

# PETSc has a tight dependency on the MPI minor version:
# the Major.Minor version of the current MPI must match the one that
# PETSc was built against, see /usr/lib/petscdir/*/x86_64-linux-gnu-real/include/petscsys.h
# Define the required version here:
MPI_DEPENDS=$(shell debian/extract_MPI_dependency)


# facilitate build-time testing (invoking OpenMPI) when building in a chroot (pbuilder or sbuild)
export OMPI_MCA_plm_rsh_agent=/bin/false
export OMPI_MCA_btl_base_warn_component_unused=0

HDF5_INCLUDE_DIR=$(shell for i in `pkg-config hdf5-mpi --cflags-only-I`; do echo $$i | grep "include/hdf5"; done | sed "s/-I//")
HDF5_LIBS=$(shell pkg-config hdf5-mpi --libs)
PETSC_HDF5_FLAGS=--with-hdf5-include=$(HDF5_INCLUDE_DIR) --with-hdf5-lib="$(HDF5_LIBS)"

VALGRIND_ARCH_LIST := amd64 arm64 armhf i386 mips64el mipsel ppc64el s390x powerpc ppc64
ifeq (,$(findstring $(space)$(DEB_HOST_ARCH)$(space), $(space)$(VALGRIND_ARCH_LIST)$(space)))
  VALGRIND_CONFIG=--with-valgrind=1
else
  VALGRIND_CONFIG=
endif

PETSC_REAL_BUILD_DIR=$(PETSC_ARCH)-real
PETSC_REAL_DEBUG_BUILD_DIR=$(PETSC_ARCH)-real-debug
PETSC_COMPLEX_BUILD_DIR=$(PETSC_ARCH)-complex
PETSC_COMPLEX_DEBUG_BUILD_DIR=$(PETSC_ARCH)-complex-debug

PETSC64_REAL_BUILD_DIR=$(PETSC_ARCH)-real-64
PETSC64_REAL_DEBUG_BUILD_DIR=$(PETSC_ARCH)-real-debug-64
PETSC64_COMPLEX_BUILD_DIR=$(PETSC_ARCH)-complex-64
PETSC64_COMPLEX_DEBUG_BUILD_DIR=$(PETSC_ARCH)-complex-debug-64

# PETSC_VERSION is used for the package names, library sonames, and
# /usr/lib/petscdir subdirectory names.
export PETSC_VERSION=$(DEB_STRIPPED_UPSTREAM_VERSION)$(PETSC_EXT)
# use only major.minor as general soname (rather than major.minor.patch.build)
export PETSC_SONAMEISH_VERSION=$(shell echo $(PETSC_VERSION) | awk 'BEGIN { FS="."}; {print $$1"."$$2 }')
export PETSC_SONAME_VERSION=$(PETSC_SONAMEISH_VERSION)t64

# PETSC_NAME is the install dir under /usr/lib and the base for package names
PETSC_NAME=petsc$(PETSC_SONAMEISH_VERSION)
PETSC_REAL_SONAME=petsc-real$(PETSC_SONAME_VERSION)
PETSC_REALISH_SONAME=petsc-real$(PETSC_SONAMEISH_VERSION)
PETSC_COMPLEX_SONAME=petsc-complex$(PETSC_SONAME_VERSION)
PETSC_COMPLEXISH_SONAME=petsc-complex$(PETSC_SONAMEISH_VERSION)

PETSC64_NAME=petsc64-$(PETSC_SONAMEISH_VERSION)
PETSC64_REAL_SONAME=petsc64-real$(PETSC_SONAME_VERSION)
PETSC64_REALISH_SONAME=petsc64-real$(PETSC_SONAMEISH_VERSION)
PETSC64_COMPLEX_SONAME=petsc64-complex$(PETSC_SONAME_VERSION)
PETSC64_COMPLEXISH_SONAME=petsc64-complex$(PETSC_SONAMEISH_VERSION)

# debian binary package names
PETSC_REAL_DEV_PACKAGE=lib$(PETSC_REALISH_SONAME)-dev
PETSC_REAL_PACKAGE=lib$(PETSC_REAL_SONAME)
PETSC_REAL_DEBUG_PACKAGE=lib$(PETSC_REAL_SONAME)-dbg
PETSC_COMPLEX_DEV_PACKAGE=lib$(PETSC_COMPLEXISH_SONAME)-dev
PETSC_COMPLEX_PACKAGE=lib$(PETSC_COMPLEX_SONAME)
PETSC_COMPLEX_DEBUG_PACKAGE=lib$(PETSC_COMPLEX_SONAME)-dbg

PETSC64_REAL_DEV_PACKAGE=lib$(PETSC64_REALISH_SONAME)-dev
PETSC64_REAL_PACKAGE=lib$(PETSC64_REAL_SONAME)
PETSC64_REAL_DEBUG_PACKAGE=lib$(PETSC64_REAL_SONAME)-dbg
PETSC64_COMPLEX_DEV_PACKAGE=lib$(PETSC64_COMPLEXISH_SONAME)-dev
PETSC64_COMPLEX_PACKAGE=lib$(PETSC64_COMPLEX_SONAME)
PETSC64_COMPLEX_DEBUG_PACKAGE=lib$(PETSC64_COMPLEX_SONAME)-dbg

PETSC_DEV_COMMON_PACKAGE=lib$(PETSC_NAME)-dev-common
export PETSC_DOC_PACKAGE=petsc$(PETSC_SONAMEISH_VERSION)-doc
export PETSC_DEV_EXAMPLE_PACKAGE=lib$(PETSC_NAME)-dev-examples

# install into /usr/lib/petscdir rather than /usr/lib/petsc
# to allow /usr/lib/petsc to be configured by alternatives
export PETSC_REAL_DIR_PREFIX=/usr/lib/petscdir/$(PETSC_NAME)/$(PETSC_ARCH)-real
export PETSC_REAL_DEBUG_DIR_PREFIX=/usr/lib/petscdir/$(PETSC_NAME)/$(PETSC_ARCH)-real-debug
export PETSC_COMPLEX_DIR_PREFIX=/usr/lib/petscdir/$(PETSC_NAME)/$(PETSC_ARCH)-complex
export PETSC_COMPLEX_DEBUG_DIR_PREFIX=/usr/lib/petscdir/$(PETSC_NAME)/$(PETSC_ARCH)-complex-debug

export PETSC64_REAL_DIR_PREFIX=/usr/lib/petscdir/$(PETSC64_NAME)/$(PETSC_ARCH)-real
export PETSC64_REAL_DEBUG_DIR_PREFIX=/usr/lib/petscdir/$(PETSC64_NAME)/$(PETSC_ARCH)-real-debug
export PETSC64_COMPLEX_DIR_PREFIX=/usr/lib/petscdir/$(PETSC64_NAME)/$(PETSC_ARCH)-complex
export PETSC64_COMPLEX_DEBUG_DIR_PREFIX=/usr/lib/petscdir/$(PETSC64_NAME)/$(PETSC_ARCH)-complex-debug

PACKAGE_REAL_INSTALL_DIR=debian/tmp/$(PETSC_NAME)-real
export PACKAGE_REAL_DEBUG_INSTALL_DIR=debian/tmp/$(PETSC_NAME)-real-debug
PACKAGE_COMPLEX_INSTALL_DIR=debian/tmp/$(PETSC_NAME)-complex
PACKAGE_COMPLEX_DEBUG_INSTALL_DIR=debian/tmp/$(PETSC_NAME)-complex-debug

PACKAGE_64_REAL_INSTALL_DIR=debian/tmp/$(PETSC64_NAME)-real
export PACKAGE_64_REAL_DEBUG_INSTALL_DIR=debian/tmp/$(PETSC64_NAME)-real-debug
PACKAGE_64_COMPLEX_INSTALL_DIR=debian/tmp/$(PETSC64_NAME)-complex
PACKAGE_64_COMPLEX_DEBUG_INSTALL_DIR=debian/tmp/$(PETSC64_NAME)-complex-debug

PETSC64_CONFIG=--with-64-bit-indices

=== debian/tests/control ===
Tests: test-petsc-common, test-petsc-complex
 test-petsc64, test-petsc64-complex
Depends: @, @builddeps@

=== debian/watch ===
version=3
opts=dversionmangle=s/\+dfsg\d//,repacksuffix=+dfsg1 \
 http://ftp.mcs.anl.gov/pub/petsc/release-snapshots/petsc-with-docs-([\d\.]+).tar.gz

## petsc 3.20.6%2Bdfsg1

=== debian/changelog ===
petsc (3.20.6+dfsg1-3) unstable; urgency=medium

  * build 64-bit petsc against scotch-int64 not scotch-long
    to avoid 32-bit systems getting a mismatch between
    SCOTCH_Num long int and PetscInt long long int.
    The error reference to "long int" is a red herring, it's just int64
  * libpetsc64-complex3.20-dev: fix alternatives link for
    libpetsc64_complex.so (not libpets64c_complex.so)

 -- Drew Parsons <dparsons@debian.org>  Thu, 22 Aug 2024 23:13:53 +0200

petsc (3.20.6+dfsg1-2) unstable; urgency=medium

  * configure 64-bit petsc to build against 64-bit (long) scotch.
    - required for building with gcc-14, for which pointers to standard
      SCOTCH_Num (int) are incompatible with pointers to 64-bit
      PetscInt (declared as long int, not int64).
    - provide lib path /usr/lib/$(DEB_HOST_MULTIARCH)/scotch-long as
      explicit RUNPATH (-rpath) in the petsc64*.so shared libraries to
      ensure the standard libptscotch.so build is not used at runtime.
    - add lintian overrides (custom-library-search-path)
      to acknowledge the intended explicit RUNPATHs
    - Closes: #1075380.

 -- Drew Parsons <dparsons@debian.org>  Wed, 21 Aug 2024 20:09:11 +0200

petsc (3.20.6+dfsg1-1) unstable; urgency=medium

  * New upstream release.
  * Build-Depends: pkgconf not pkg-config
  * add Depends: ${fortran:Depends} to -dev (and -dbg) packages
  * drop dh_strip override, so the debug package is not treated as the
    dbgsym symbols package of the main production package. The debug
    build provides additional output that may be useful when designing
    and profiling PETSc applications.
  * specify in -dbg package descriptions that they are built using
    --with-debugging=1
  * add loong64 to the list of arches supporting 64-bit hypre.
    Closes: #1060050.
  * Standards-Version: 4.7.0

 -- Drew Parsons <dparsons@debian.org>  Thu, 16 May 2024 21:51:32 +0200

petsc (3.20.3+dfsg1-1exp1) experimental; urgency=medium

  [ Francesco Ballarin ]
  * New upstream version 3.20.3+dfsg1
  * debian/watch now downloads from https://web.cels.anl.gov
  * Refresh build-no-rpath.patch, clean-no-double-colon.patch,
    lib-versions.patch, ptscotch_without_bison_MR5787.diff, soname_extension,
    sprng-2.patch so that they apply without offset and fuzz.
  * Refresh docs.patch with updated url of the PDF version of the PETSc
    manual.
  * Refresh label_tests.patch, nocleanup.patch, petscmatmod_split.patch which
    failed to apply due to upstream changes.

 -- Drew Parsons <dparsons@debian.org>  Tue, 12 Mar 2024 19:57:49 +0100

## petsc 3.20.6+dfsg1

=== debian/changelog ===
petsc (3.20.6+dfsg1-1ubuntu1) oracular; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - debian/patches/gcc-13.patch: fix misdetection of required C++
      library with gcc-13.
    - debian/rules: pass -Wl,-z,defs to the linker to guard against future
      misbuilds.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 18 May 2024 10:01:06 +0200

petsc (3.19.6+dfsg1-2.2ubuntu3) oracular; urgency=medium

  * Rebuild against new libhypre-2.29.0.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 18 May 2024 08:34:10 +0200

=== debian/control ===
Source: petsc
Section: devel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: "Adam C. Powell, IV" <hazelsct@debian.org>, Drew Parsons <dparsons@debian.org>
Standards-Version: 4.7.0
Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13), python3, gfortran,
 pkgconf, dh-python,
 dh-fortran-mod,
 gdb,
 mpi-default-dev (>= 1.0.2),
 ocl-icd-opencl-dev | opencl-dev,
 libblas-dev | libopenblas-dev | libatlas-base-dev | libblas.so,
 liblapack-dev | libopenblas-dev | libatlas-base-dev | liblapack.so,
 libsuitesparse-dev (>= 1:5.6.0),
 libhypre-dev (>= 2.21.0),
 libhypre64m-dev (>= 2.21.0) [amd64 arm64 mips64el ppc64el s390x alpha ia64 loong64 ppc64 riscv64 sparc64],
 libptscotch-dev,
 libhdf5-mpi-dev (>= 1.10.6+repack-1),
 libscalapack-mpi-dev,
 libmumps-dev (>= 5.2.1~), libmumps64-dev,
 libfftw3-dev, libfftw3-mpi-dev, libssl-dev,
 libsuperlu-dev (>= 5.2.1), libsuperlu-dist-dev (>= 6.1.1),
 libtrilinos-ml-dev [amd64 arm64 ppc64el s390x ppc64],
 libtrilinos-zoltan-dev [amd64 arm64 ppc64el s390x ppc64],
 libx11-dev,
 libyaml-dev,
 valgrind-mpi [amd64 arm64 armhf i386 mips64el mipsel ppc64el s390x powerpc ppc64],
 sphinx-common | python3-sphinx | dh-sequence-sphinxdoc
Build-Depends-Indep: libjs-sphinxdoc, libjs-mathjax,
 libjs-jquery, libjs-jquery-ui
Vcs-Git: https://salsa.debian.org/science-team/petsc.git
Vcs-Browser: https://salsa.debian.org/science-team/petsc
Homepage: http://www.mcs.anl.gov/petsc

Package: petsc-dev
Architecture: all
Multi-Arch: foreign
Section: libdevel
Depends: libpetsc-real-dev, ${misc:Depends}
Description: Virtual package depending on latest PETSc development package
 PETSc is the "Portable Extensible Toolkit for Scientific Computation", a suite
 of data structures and routines for the scalable (parallel) solution of
 scientific applications modeled by partial differential equations.  It employs
 the MPI standard for all message-passing communication.  Several sample
 scientific applications, as well as various papers and talks, demonstrate the
 features of the PETSc libraries.
 .
 This metapackage installs libpetsc-real-dev, which will always depend
 on the most recent version of PETSc with real number support. So if
 you install it then you will get upgrades automatically.

Package: libpetsc-real-dev
Architecture: all
Multi-Arch: foreign
Section: libdevel
Depends: libpetsc-real3.20-dev, ${misc:Depends}
Description: Virtual package depending on latest PETSc development package
 PETSc is the "Portable Extensible Toolkit for Scientific Computation", a suite
 of data structures and routines for the scalable (parallel) solution of
 scientific applications modeled by partial differential equations.  It employs
 the MPI standard for all message-passing communication.  Several sample
 scientific applications, as well as various papers and talks, demonstrate the
 features of the PETSc libraries.
 .
 This is a dummy package which depends on the most recent version of
 libpetsc-realX-dev with real number support (X=version).

Package: libpetsc-complex-dev
Architecture: all
Multi-Arch: foreign
Section: libdevel
Depends: libpetsc-complex3.20-dev, ${misc:Depends}
Description: Virtual package depending on latest PETSc development package
 PETSc is the "Portable Extensible Toolkit for Scientific Computation", a suite
 of data structures and routines for the scalable (parallel) solution of
 scientific applications modeled by partial differential equations.  It employs
 the MPI standard for all message-passing communication.  Several sample
 scientific applications, as well as various papers and talks, demonstrate the
 features of the PETSc libraries.
 .
 This is a dummy package which depends on the most recent version of
 libpetsc-complexX-dev with complex number support (X=version).

Package: libpetsc-real3.20-dev
Multi-Arch: same
Architecture: any
Section: libdevel
Depends: libpetsc-real3.20 (= ${binary:Version}),
 libpetsc3.20-dev-common (= ${source:Version}),
 ${MPI:Depends},
 libhypre-dev (>= 2.15.1),
 libmumps-dev,
 libtrilinos-ml-dev [amd64 arm64 ppc64el s390x ppc64],
 libtrilinos-zoltan-dev [amd64 arm64 ppc64el s390x ppc64],
 gfortran,
 valgrind-mpi [amd64 arm64 armhf i386 mips64el mipsel ppc64el s390x powerpc ppc64],
 ${misc:Depends}, ${fortran:Depends},
 python3, ${python3:Depends}
Conflicts: libpetsc3.6.3-dev (<< 3.6.3.dfsg2-2), libpetsc-complex-3.6.3-dev (<< 3.6.3.dfsg2-2),
 libpetsc3.6.2-dev (<= 3.6.2.dfsg1-3), libpetsc-complex-3.6.2-dev (<= 3.6.2.dfsg1-3)
Recommends: libpetsc3.20-dev-examples, ksh | mksh | pdksh | zsh
Suggests: petsc-dev, libpetsc-real3.20-dbg (= ${binary:Version}), petsc3.20-doc, libluminate-dev
Description: Static libraries, shared links, header files for PETSc
 PETSc is the "Portable Extensible Toolkit for Scientific
 Computation", a suite of data structures and routines for the
 scalable (parallel) solution of scientific applications modeled by
 partial differential equations.  It employs the MPI standard for all
 message-passing communication.  Several sample scientific
 applications, as well as various papers and talks, demonstrate the
 features of the PETSc libraries.
 .
 This package provides the development files for building applications
 using PETSc 3.20 with real numbers.

Package: libpetsc-real3.20
Architecture: any
Multi-Arch: same
Section: libs
Provides: libpetsc3.20, ${t64:Provides}
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: libpetsc3.6 (<< 3.6.2.dfsg1-4)
Breaks: libpetsc-real3.10, libslepc-real3.10, libpetsc3.10-dev-common, libpetsc3.10-dev-examples
Replaces: libpetsc3.6 (<< 3.6.2.dfsg1-4)
Description: Shared libraries for version 3.20 of PETSc
 PETSc is the "Portable Extensible Toolkit for Scientific
 Computation", a suite of data structures and routines for the
 scalable (parallel) solution of scientific applications modeled by
 partial differential equations.  It employs the MPI standard for all
 message-passing communication.  Several sample scientific
 applications, as well as various papers and talks, demonstrate the
 features of the PETSc libraries.
 .
 This package contains the PETSc 3.20 shared library for real numbers.
 .
 It provides soname libpetsc-real3.20

Package: libpetsc3.20-dev-common
Architecture: all
Multi-Arch: foreign
Section: libdevel
Depends: libjs-jquery, libjs-jquery-ui,
 libjs-mathjax,
 libblas-dev | libopenblas-dev | libatlas-base-dev | libblas.so,
 liblapack-dev | libopenblas-dev | libatlas-base-dev | liblapack.so,
 libsuitesparse-dev,
 libptscotch-dev, libscalapack-mpi-dev,
 libfftw3-dev, libfftw3-mpi-dev, libssl-dev,
 ocl-icd-opencl-dev | opencl-dev,
 libhdf5-mpi-dev (>= 1.8.8),
 libsuperlu-dev (>= 5.2), libsuperlu-dist-dev,
 libx11-dev,
 libyaml-dev,
 ${misc:Depends}, ${python3:Depends},
 ${sphinxdoc:Depends}
Recommends: libpetsc-real3.20-dev | libpetsc-complex3.20-dev
Description: Common header and support dev files for PETSc
 PETSc is the "Portable Extensible Toolkit for Scientific
 Computation", a suite of data structures and routines for the
 scalable (parallel) solution of scientific applications modeled by
 partial differential equations.  It employs the MPI standard for all
 message-passing communication.  Several sample scientific
 applications, as well as various papers and talks, demonstrate the
 features of the PETSc libraries.
 .
 This package provides header and other support files common to the
 various dev packages (with real or complex number support) for PETSc 3.20.

Package: libpetsc3.20-dev-examples
Architecture: all
Multi-Arch: foreign
Section: libdevel
Depends: ${misc:Depends}, ${python3:Depends},
 libjs-mathjax
Recommends: ksh | mksh | pdksh | zsh,
 libpetsc-real3.20-dev | libpetsc-complex3.20-dev | libpetsc-real3.20-dbg | libpetsc-complex3.20-dbg
Suggests: petsc3.20-doc
Description: Static libraries, shared links, header files for PETSc
 PETSc is the "Portable Extensible Toolkit for Scientific
 Computation", a suite of data structures and routines for the
 scalable (parallel) solution of scientific applications modeled by
 partial differential equations.  It employs the MPI standard for all
 message-passing communication.  Several sample scientific
 applications, as well as various papers and talks, demonstrate the
 features of the PETSc libraries.
 .
 This package provides example, test, and tutorial scripts for PETSc 3.20.

Package: libpetsc-real3.20-dbg
Architecture: any
Multi-Arch: same
Section: debug
Pre-Depends: ${misc:Pre-Depends}
Depends: libpetsc-real3.20-dev (= ${binary:Version}),
 libpetsc3.20-dev-common (= ${source:Version}),
 libtrilinos-ml-dev [amd64 arm64 ppc64el s390x ppc64],
 libtrilinos-zoltan-dev [amd64 arm64 ppc64el s390x ppc64],
 ${misc:Depends}, ${shlibs:Depends}, ${fortran:Depends},
 python3, ${python3:Depends}
Recommends: libpetsc3.20-dev-examples, ksh | mksh | pdksh | zsh
Provides: petsc3.20-dbg, ${t64:Provides}
Description: Debugging libraries for PETSc
 PETSc is the "Portable Extensible Toolkit for Scientific
 Computation", a suite of data structures and routines for the
 scalable (parallel) solution of scientific applications modeled by
 partial differential equations.  It employs the MPI standard for all
 message-passing communication.  Several sample scientific
 applications, as well as various papers and talks, demonstrate the
 features of the PETSc libraries.
 .
 This package provides the development files and debugging libraries for
 debugging applications using PETSc 3.20 with real numbers.
 .
 Libraries include unstripped symbols, but this package is also built with
 internal PETSc debugging activated (--with-debugging=1).

Package: petsc3.20-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: sphinx-common, libjs-sphinxdoc, ${misc:Depends}, ${sphinxdoc:Depends}
Suggests: libpetsc-real3.20-dev (= ${binary:Version}), illuminator-doc
Description: Documentation and examples for PETSc
 PETSc is the "Portable Extensible Toolkit for Scientific
 Computation", a suite of data structures and routines for the
 scalable (parallel) solution of scientific applications modeled by
 partial differential equations.  It employs the MPI standard for all
 message-passing communication.  Several sample scientific
 applications, as well as various papers and talks, demonstrate the
 features of the PETSc libraries.
 .
 This package contains documentation for developing with PETSc 3.20.

Package: libpetsc-complex3.20-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libpetsc-complex3.20 (= ${binary:Version}),
 libpetsc3.20-dev-common (= ${source:Version}),
 ${MPI:Depends},
 libmumps-dev,
 libtrilinos-zoltan-dev [amd64 arm64 ppc64el s390x ppc64],
 gfortran,
 valgrind-mpi [amd64 arm64 armhf i386 mips64el mipsel ppc64el s390x powerpc ppc64],
 ${misc:Depends}, ${fortran:Depends},
 python3, ${python3:Depends}
Conflicts: libpetsc-complex-3.6.3-dev (<< 3.6.3.dfsg2-2), libpetsc3.6.3-dev (<< 3.6.3.dfsg2-2),
 libpetsc3.6.2-dev (<= 3.6.2.dfsg1-3), libpetsc-complex-3.6.2-dev (<= 3.6.2.dfsg1-3)
Recommends: libpetsc3.20-dev-examples, ksh | mksh | pdksh | zsh
Suggests: petsc-dev, libpetsc-complex3.20-dbg (= ${binary:Version}), petsc3.20-doc, libluminate-dev
Description: Static libraries, shared links, header files for PETSc
 PETSc is the "Portable Extensible Toolkit for Scientific
 Computation", a suite of data structures and routines for the
 scalable (parallel) solution of scientific applications modeled by
 partial differential equations.  It employs the MPI standard for all
 message-passing communication.  Several sample scientific
 applications, as well as various papers and talks, demonstrate the
 features of the PETSc libraries.
 .
 This package provides the development files for building applications
 using PETSc 3.20 with support for complex numbers.
 .
 Note HYPRE is not supported with PETSc complex.

Package: libpetsc-complex3.20

=== debian/rules ===
--- 
+++ 
@@ -94,39 +94,34 @@
 # /usr/lib/petscdir subdirectory names.
 export PETSC_VERSION=$(DEB_STRIPPED_UPSTREAM_VERSION)$(PETSC_EXT)
 # use only major.minor as general soname (rather than major.minor.patch.build)
-export PETSC_SONAMEISH_VERSION=$(shell echo $(PETSC_VERSION) | awk 'BEGIN { FS="."}; {print $$1"."$$2 }')
-export PETSC_SONAME_VERSION=$(PETSC_SONAMEISH_VERSION)t64
+export PETSC_SONAME_VERSION=$(shell echo $(PETSC_VERSION) | awk 'BEGIN { FS="."}; {print $$1"."$$2 }')
 
 # PETSC_NAME is the install dir under /usr/lib and the base for package names
-PETSC_NAME=petsc$(PETSC_SONAMEISH_VERSION)
+PETSC_NAME=petsc$(PETSC_SONAME_VERSION)
 PETSC_REAL_SONAME=petsc-real$(PETSC_SONAME_VERSION)
-PETSC_REALISH_SONAME=petsc-real$(PETSC_SONAMEISH_VERSION)
 PETSC_COMPLEX_SONAME=petsc-complex$(PETSC_SONAME_VERSION)
-PETSC_COMPLEXISH_SONAME=petsc-complex$(PETSC_SONAMEISH_VERSION)
 
-PETSC64_NAME=petsc64-$(PETSC_SONAMEISH_VERSION)
+PETSC64_NAME=petsc64-$(PETSC_SONAME_VERSION)
 PETSC64_REAL_SONAME=petsc64-real$(PETSC_SONAME_VERSION)
-PETSC64_REALISH_SONAME=petsc64-real$(PETSC_SONAMEISH_VERSION)
 PETSC64_COMPLEX_SONAME=petsc64-complex$(PETSC_SONAME_VERSION)
-PETSC64_COMPLEXISH_SONAME=petsc64-complex$(PETSC_SONAMEISH_VERSION)
 
 # debian binary package names
-PETSC_REAL_DEV_PACKAGE=lib$(PETSC_REALISH_SONAME)-dev
+PETSC_REAL_DEV_PACKAGE=lib$(PETSC_REAL_SONAME)-dev
 PETSC_REAL_PACKAGE=lib$(PETSC_REAL_SONAME)
 PETSC_REAL_DEBUG_PACKAGE=lib$(PETSC_REAL_SONAME)-dbg
-PETSC_COMPLEX_DEV_PACKAGE=lib$(PETSC_COMPLEXISH_SONAME)-dev
+PETSC_COMPLEX_DEV_PACKAGE=lib$(PETSC_COMPLEX_SONAME)-dev
 PETSC_COMPLEX_PACKAGE=lib$(PETSC_COMPLEX_SONAME)
 PETSC_COMPLEX_DEBUG_PACKAGE=lib$(PETSC_COMPLEX_SONAME)-dbg
 
-PETSC64_REAL_DEV_PACKAGE=lib$(PETSC64_REALISH_SONAME)-dev
+PETSC64_REAL_DEV_PACKAGE=lib$(PETSC64_REAL_SONAME)-dev
 PETSC64_REAL_PACKAGE=lib$(PETSC64_REAL_SONAME)
 PETSC64_REAL_DEBUG_PACKAGE=lib$(PETSC64_REAL_SONAME)-dbg
-PETSC64_COMPLEX_DEV_PACKAGE=lib$(PETSC64_COMPLEXISH_SONAME)-dev
+PETSC64_COMPLEX_DEV_PACKAGE=lib$(PETSC64_COMPLEX_SONAME)-dev
 PETSC64_COMPLEX_PACKAGE=lib$(PETSC64_COMPLEX_SONAME)
 PETSC64_COMPLEX_DEBUG_PACKAGE=lib$(PETSC64_COMPLEX_SONAME)-dbg
 
 PETSC_DEV_COMMON_PACKAGE=lib$(PETSC_NAME)-dev-common
-export PETSC_DOC_PACKAGE=petsc$(PETSC_SONAMEISH_VERSION)-doc
+export PETSC_DOC_PACKAGE=petsc$(PETSC_SONAME_VERSION)-doc
 export PETSC_DEV_EXAMPLE_PACKAGE=lib$(PETSC_NAME)-dev-examples
 
 # install into /usr/lib/petscdir rather than /usr/lib/petsc
@@ -153,3 +148,9 @@
 
 PETSC64_CONFIG=--with-64-bit-indices
 
+CONFIGURATION_OPTIONS=--with-shared-libraries --with-pic=1 \
+	  --with-cc=mpicc --with-cxx=mpicxx --with-fc=mpif90 \
+	  --with-cxx-dialect=C++11 \
+	  --with-opencl=1 \
+	  --with-blas-lib=-lblas --with-lapack-lib=-llapack \
+	  --with-scalapack=1 --with-scalapack-lib=-lscalapack-$(PETSC_MPI) \

## petsc 3.21.6+dfsg1

=== debian/changelog ===
petsc (3.21.6+dfsg1-2ubuntu2) plucky; urgency=medium

  * No-change rebuild for libsuperlu7

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Mon, 04 Nov 2024 15:17:00 +0000

petsc (3.21.6+dfsg1-2ubuntu1) plucky; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - debian/rules: pass -Wl,-z,defs to the linker to guard against future
      misbuilds.
    - debian/patches/gcc-13.patch: fix misdetection of required C++
      library with gcc-13.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 01 Nov 2024 15:40:36 +0100

petsc (3.21.6+dfsg1-2) unstable; urgency=medium

  * Add Francesco Ballarin to uploaders
  * Revert setting tight dev package dependency on MPI version.
    Instead, simply list mpi-default-dev as Build-Depends and Depends.
    Bug #828987 in July 2016 (version 3.6.4.dfsg1-3) forced us
    to define a control variable ${MPI:Depends} to automatically
    set up a string like
        libopenmpi-dev (>= 1.10.3), libopenmpi-dev (<< 1.10.4)
    and use it in override_dh_gencontrol.
    However, such a tight dependency control is unnecessary nowadays,
    since OpenMPI 5 guarantees ABI compatibility.
    Closes: #1085405
  * Temporarily drop Build-Depends and Depends on libtrilinos-ml-dev and
    libtrilinos-zoltan-dev while trilinos gets rebuilt against OpenMPI 5.
    This change will be reverted in a future upload.
  * Build-Depends: increment mpi-default-dev lower bound to >= 1.17 to prevent
    this package from being accidentally built against OpenMPI 4.

 -- Francesco Ballarin <francesco.ballarin@unicatt.it>  Sun, 20 Oct 2024 10:17:39 +0000

petsc (3.21.6+dfsg1-1) unstable; urgency=medium

  * New upstream release.  Upload for Transition #1082552.

 -- Drew Parsons <dparsons@debian.org>  Sun, 06 Oct 2024 23:54:39 +0200

petsc (3.21.4+dfsg1-1exp2) experimental; urgency=medium

  * debian patch fix_build_tests_MR7789.patch applies upstream MR#7789
    to reenable build tests. Closes: #1079566.

 -- Drew Parsons <dparsons@debian.org>  Fri, 30 Aug 2024 16:22:03 +0200

petsc (3.21.4+dfsg1-1exp1) experimental; urgency=medium

  * New upstream release. New ABI 3.21.
  * add docs/petsc4py to Files-Excluded in debian/copyright
  * debian/copyright: drop systems/Apple/* from excluded files
    (no longer shipped in upstream tarball)
  * disable build-time tests on all arches. See Bug#1079566
    and https://gitlab.com/petsc/petsc/-/issues/1634

 -- Drew Parsons <dparsons@debian.org>  Sat, 24 Aug 2024 18:22:02 +0200

petsc (3.20.6+dfsg1-3ubuntu3) oracular; urgency=medium

  * No-change rebuild against mpi-defaults 1.17

 -- Graham Inggs <ginggs@ubuntu.com>  Sat, 21 Sep 2024 14:51:30 +0000

petsc (3.20.6+dfsg1-3ubuntu2) oracular; urgency=medium

  * Merge with Debian; remaining changes:
    - debian/rules: pass -Wl,-z,defs to the linker to guard against future
      misbuilds.
    - debian/patches/gcc-13.patch: fix misdetection of required C++
      library with gcc-13.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 23 Aug 2024 14:34:09 +0200

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,17 @@
 Source: petsc
 Section: devel
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
-Uploaders: "Adam C. Powell, IV" <hazelsct@debian.org>, Drew Parsons <dparsons@debian.org>
+Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Uploaders:
+ "Adam C. Powell, IV" <hazelsct@debian.org>,
+ Drew Parsons <dparsons@debian.org>,
+ Francesco Ballarin <francesco.ballarin@unicatt.it>
 Standards-Version: 4.7.0
 Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13), python3, gfortran,
  pkgconf, dh-python,
  dh-fortran-mod,
  gdb,
- mpi-default-dev (>= 1.0.2),
+ mpi-default-dev (>= 1.17),
  ocl-icd-opencl-dev | opencl-dev,
  libblas-dev | libopenblas-dev | libatlas-base-dev | libblas.so,
  liblapack-dev | libopenblas-dev | libatlas-base-dev | liblapack.so,
@@ -22,8 +24,6 @@
  libmumps-dev (>= 5.2.1~), libmumps64-dev,
  libfftw3-dev, libfftw3-mpi-dev, libssl-dev,
  libsuperlu-dev (>= 5.2.1), libsuperlu-dist-dev (>= 6.1.1),
- libtrilinos-ml-dev [amd64 arm64 ppc64el s390x ppc64],
- libtrilinos-zoltan-dev [amd64 arm64 ppc64el s390x ppc64],
  libx11-dev,
  libyaml-dev,
  valgrind-mpi [amd64 arm64 armhf i386 mips64el mipsel ppc64el s390x powerpc ppc64],
@@ -55,7 +55,7 @@
 Architecture: all
 Multi-Arch: foreign
 Section: libdevel
-Depends: libpetsc-real3.20-dev, ${misc:Depends}
+Depends: libpetsc-real3.21-dev, ${misc:Depends}
 Description: Virtual package depending on latest PETSc development package
  PETSc is the "Portable Extensible Toolkit for Scientific Computation", a suite
  of data structures and routines for the scalable (parallel) solution of
@@ -71,7 +71,7 @@
 Architecture: all
 Multi-Arch: foreign
 Section: libdevel
-Depends: libpetsc-complex3.20-dev, ${misc:Depends}
+Depends: libpetsc-complex3.21-dev, ${misc:Depends}
 Description: Virtual package depending on latest PETSc development package
  PETSc is the "Portable Extensible Toolkit for Scientific Computation", a suite
  of data structures and routines for the scalable (parallel) solution of
@@ -83,25 +83,23 @@
  This is a dummy package which depends on the most recent version of
  libpetsc-complexX-dev with complex number support (X=version).
 
-Package: libpetsc-real3.20-dev
-Multi-Arch: same
-Architecture: any
-Section: libdevel
-Depends: libpetsc-real3.20 (= ${binary:Version}),
- libpetsc3.20-dev-common (= ${source:Version}),
- ${MPI:Depends},
+Package: libpetsc-real3.21-dev
+Multi-Arch: same
+Architecture: any
+Section: libdevel
+Depends: libpetsc-real3.21 (= ${binary:Version}),
+ libpetsc3.21-dev-common (= ${source:Version}),
+ mpi-default-dev,
  libhypre-dev (>= 2.15.1),
  libmumps-dev,
- libtrilinos-ml-dev [amd64 arm64 ppc64el s390x ppc64],
- libtrilinos-zoltan-dev [amd64 arm64 ppc64el s390x ppc64],
  gfortran,
  valgrind-mpi [amd64 arm64 armhf i386 mips64el mipsel ppc64el s390x powerpc ppc64],
  ${misc:Depends}, ${fortran:Depends},
  python3, ${python3:Depends}
 Conflicts: libpetsc3.6.3-dev (<< 3.6.3.dfsg2-2), libpetsc-complex-3.6.3-dev (<< 3.6.3.dfsg2-2),
  libpetsc3.6.2-dev (<= 3.6.2.dfsg1-3), libpetsc-complex-3.6.2-dev (<= 3.6.2.dfsg1-3)
-Recommends: libpetsc3.20-dev-examples, ksh | mksh | pdksh | zsh
-Suggests: petsc-dev, libpetsc-real3.20-dbg (= ${binary:Version}), petsc3.20-doc, libluminate-dev
+Recommends: libpetsc3.21-dev-examples, ksh | mksh | pdksh | zsh
+Suggests: petsc-dev, libpetsc-real3.21-dbg (= ${binary:Version}), petsc3.21-doc, libluminate-dev
 Description: Static libraries, shared links, header files for PETSc
  PETSc is the "Portable Extensible Toolkit for Scientific
  Computation", a suite of data structures and routines for the
@@ -112,32 +110,32 @@
  features of the PETSc libraries.
  .
  This package provides the development files for building applications
- using PETSc 3.20 with real numbers.
-
-Package: libpetsc-real3.20
+ using PETSc 3.21 with real numbers.
+
+Package: libpetsc-real3.21
 Architecture: any
 Multi-Arch: same
 Section: libs
-Provides: libpetsc3.20, ${t64:Provides}
+Provides: libpetsc3.21, ${t64:Provides}
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Conflicts: libpetsc3.6 (<< 3.6.2.dfsg1-4)
 Breaks: libpetsc-real3.10, libslepc-real3.10, libpetsc3.10-dev-common, libpetsc3.10-dev-examples
 Replaces: libpetsc3.6 (<< 3.6.2.dfsg1-4)
-Description: Shared libraries for version 3.20 of PETSc
- PETSc is the "Portable Extensible Toolkit for Scientific
- Computation", a suite of data structures and routines for the
- scalable (parallel) solution of scientific applications modeled by
- partial differential equations.  It employs the MPI standard for all
- message-passing communication.  Several sample scientific
- applications, as well as various papers and talks, demonstrate the
- features of the PETSc libraries.
- .
- This package contains the PETSc 3.20 shared library for real numbers.
- .
- It provides soname libpetsc-real3.20
-
-Package: libpetsc3.20-dev-common
+Description: Shared libraries for version 3.21 of PETSc
+ PETSc is the "Portable Extensible Toolkit for Scientific
+ Computation", a suite of data structures and routines for the
+ scalable (parallel) solution of scientific applications modeled by
+ partial differential equations.  It employs the MPI standard for all
+ message-passing communication.  Several sample scientific
+ applications, as well as various papers and talks, demonstrate the
+ features of the PETSc libraries.
+ .
+ This package contains the PETSc 3.21 shared library for real numbers.
+ .
+ It provides soname libpetsc-real3.21
+
+Package: libpetsc3.21-dev-common
 Architecture: all
 Multi-Arch: foreign
 Section: libdevel
@@ -155,7 +153,7 @@
  libyaml-dev,
  ${misc:Depends}, ${python3:Depends},
  ${sphinxdoc:Depends}
-Recommends: libpetsc-real3.20-dev | libpetsc-complex3.20-dev
+Recommends: libpetsc-real3.21-dev | libpetsc-complex3.21-dev
 Description: Common header and support dev files for PETSc
  PETSc is the "Portable Extensible Toolkit for Scientific
  Computation", a suite of data structures and routines for the
@@ -166,17 +164,17 @@
  features of the PETSc libraries.
  .
  This package provides header and other support files common to the
- various dev packages (with real or complex number support) for PETSc 3.20.
-
-Package: libpetsc3.20-dev-examples
+ various dev packages (with real or complex number support) for PETSc 3.21.
+
+Package: libpetsc3.21-dev-examples
 Architecture: all
 Multi-Arch: foreign
 Section: libdevel
 Depends: ${misc:Depends}, ${python3:Depends},
  libjs-mathjax
 Recommends: ksh | mksh | pdksh | zsh,
- libpetsc-real3.20-dev | libpetsc-complex3.20-dev | libpetsc-real3.20-dbg | libpetsc-complex3.20-dbg
-Suggests: petsc3.20-doc
+ libpetsc-real3.21-dev | libpetsc-complex3.21-dev | libpetsc-real3.21-dbg | libpetsc-complex3.21-dbg
+Suggests: petsc3.21-doc
 Description: Static libraries, shared links, header files for PETSc
  PETSc is the "Portable Extensible Toolkit for Scientific
  Computation", a suite of data structures and routines for the
@@ -186,21 +184,19 @@
  applications, as well as various papers and talks, demonstrate the
  features of the PETSc libraries.
  .
- This package provides example, test, and tutorial scripts for PETSc 3.20.
-
-Package: libpetsc-real3.20-dbg
+ This package provides example, test, and tutorial scripts for PETSc 3.21.
+
+Package: libpetsc-real3.21-dbg
 Architecture: any
 Multi-Arch: same
 Section: debug
 Pre-Depends: ${misc:Pre-Depends}
-Depends: libpetsc-real3.20-dev (= ${binary:Version}),
- libpetsc3.20-dev-common (= ${source:Version}),
- libtrilinos-ml-dev [amd64 arm64 ppc64el s390x ppc64],
- libtrilinos-zoltan-dev [amd64 arm64 ppc64el s390x ppc64],
+Depends: libpetsc-real3.21-dev (= ${binary:Version}),
+ libpetsc3.21-dev-common (= ${source:Version}),
  ${misc:Depends}, ${shlibs:Depends}, ${fortran:Depends},
  python3, ${python3:Depends}
-Recommends: libpetsc3.20-dev-examples, ksh | mksh | pdksh | zsh
-Provides: petsc3.20-dbg, ${t64:Provides}
+Recommends: libpetsc3.21-dev-examples, ksh | mksh | pdksh | zsh
+Provides: petsc3.21-dbg, ${t64:Provides}
 Description: Debugging libraries for PETSc
  PETSc is the "Portable Extensible Toolkit for Scientific
  Computation", a suite of data structures and routines for the
@@ -211,17 +207,17 @@
  features of the PETSc libraries.
  .
  This package provides the development files and debugging libraries for
- debugging applications using PETSc 3.20 with real numbers.
+ debugging applications using PETSc 3.21 with real numbers.
  .
  Libraries include unstripped symbols, but this package is also built with
  internal PETSc debugging activated (--with-debugging=1).
 
-Package: petsc3.20-doc
+Package: petsc3.21-doc
 Architecture: all
 Multi-Arch: foreign
 Section: doc
 Depends: sphinx-common, libjs-sphinxdoc, ${misc:Depends}, ${sphinxdoc:Depends}
-Suggests: libpetsc-real3.20-dev (= ${binary:Version}), illuminator-doc
+Suggests: libpetsc-real3.21-dev (= ${binary:Version}), illuminator-doc
 Description: Documentation and examples for PETSc
  PETSc is the "Portable Extensible Toolkit for Scientific
  Computation", a suite of data structures and routines for the
@@ -231,25 +227,24 @@
  applications, as well as various papers and talks, demonstrate the
  features of the PETSc libraries.
  .
- This package contains documentation for developing with PETSc 3.20.
-
-Package: libpetsc-complex3.20-dev
-Architecture: any
-Multi-Arch: same
-Section: libdevel
-Depends: libpetsc-complex3.20 (= ${binary:Version}),
- libpetsc3.20-dev-common (= ${source:Version}),
- ${MPI:Depends},
+ This package contains documentation for developing with PETSc 3.21.
+
+Package: libpetsc-complex3.21-dev
+Architecture: any
+Multi-Arch: same
+Section: libdevel
+Depends: libpetsc-complex3.21 (= ${binary:Version}),
+ libpetsc3.21-dev-common (= ${source:Version}),
+ mpi-default-dev,
  libmumps-dev,
- libtrilinos-zoltan-dev [amd64 arm64 ppc64el s390x ppc64],
  gfortran,
  valgrind-mpi [amd64 arm64 armhf i386 mips64el mipsel ppc64el s390x powerpc ppc64],
  ${misc:Depends}, ${fortran:Depends},
  python3, ${python3:Depends}
 Conflicts: libpetsc-complex-3.6.3-dev (<< 3.6.3.dfsg2-2), libpetsc3.6.3-dev (<< 3.6.3.dfsg2-2),
  libpetsc3.6.2-dev (<= 3.6.2.dfsg1-3), libpetsc-complex-3.6.2-dev (<= 3.6.2.dfsg1-3)
-Recommends: libpetsc3.20-dev-examples, ksh | mksh | pdksh | zsh
-Suggests: petsc-dev, libpetsc-complex3.20-dbg (= ${binary:Version}), petsc3.20-doc, libluminate-dev
+Recommends: libpetsc3.21-dev-examples, ksh | mksh | pdksh | zsh
+Suggests: petsc-dev, libpetsc-complex3.21-dbg (= ${binary:Version}), petsc3.21-doc, libluminate-dev
 Description: Static libraries, shared links, header files for PETSc
  PETSc is the "Portable Extensible Toolkit for Scientific
  Computation", a suite of data structures and routines for the
@@ -260,8 +255,17 @@
  features of the PETSc libraries.
  .
  This package provides the development files for building applications
- using PETSc 3.20 with support for complex numbers.
+ using PETSc 3.21 with support for complex numbers.
  .
  Note HYPRE is not supported with PETSc complex.
 
-Package: libpetsc-complex3.20
+Package: libpetsc-complex3.21
+Provides: ${t64:Provides}
+Architecture: any
+Multi-Arch: same
+Section: libs
+Pre-Depends: ${misc:Pre-Depends}
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Conflicts: libpetsc-complex-3.6 (<< 3.6.2.dfsg1-4)
+Breaks: libpetsc-complex3.10, libslepc-complex3.10, libpetsc3.10-dev-common, libpetsc3.10-dev-examples
+Replaces: libpetsc-complex-3.6 (<< 3.6.2.dfsg1-4)

=== debian/rules ===
--- 
+++ 
@@ -57,13 +57,6 @@
 # available at build time.
 include /usr/share/mpi-default-dev/debian_defaults
 PETSC_MPI=$(ARCH_DEFAULT_MPI_IMPL)
-
-# PETSc has a tight dependency on the MPI minor version:
-# the Major.Minor version of the current MPI must match the one that
-# PETSc was built against, see /usr/lib/petscdir/*/x86_64-linux-gnu-real/include/petscsys.h
-# Define the required version here:
-MPI_DEPENDS=$(shell debian/extract_MPI_dependency)
-
 
 # facilitate build-time testing (invoking OpenMPI) when building in a chroot (pbuilder or sbuild)
 export OMPI_MCA_plm_rsh_agent=/bin/false
@@ -154,3 +147,12 @@
 	  --with-opencl=1 \
 	  --with-blas-lib=-lblas --with-lapack-lib=-llapack \
 	  --with-scalapack=1 --with-scalapack-lib=-lscalapack-$(PETSC_MPI) \
+	  --with-fftw=1 --with-fftw-include=[] --with-fftw-lib="-lfftw3 -lfftw3_mpi" \
+	  --with-yaml=1 \
+	  $(VALGRIND_CONFIG) \
+	  $(PETSC_HDF5_FLAGS) \
+          --CXX_LINKER_FLAGS="-Wl,--no-as-needed -Wl,-z,defs" \
+          --CC_LINKER_FLAGS="-Wl,-z,defs"
+
+
+# hypre is only supported with real numbers, not complex
